﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ScaleRectangle
{
    public partial class FormMain : Form
    {
        float scale = 1.0f;
        Rectangle rect = new Rectangle(0, 0, 1, 1);

        void setScale(String text)
        {
            float result;
            if (!float.TryParse(text, out result))
            {
                result = 1.0f;
            }
            scale = result;
        }
        
        public FormMain()
        {
            InitializeComponent();
        }

        private void radioButtonPageScale_Click(object sender, EventArgs e)
        {
            toolStripStatusLabelMouseHit.Text = "";
            setScale((sender as RadioButton).Tag.ToString());
            panelDraw.Invalidate();
        }

        private void FormMain_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            GraphicsState state = g.Save();
            g.PageUnit = GraphicsUnit.Inch;
            g.PageScale = scale;
            using (Pen pen = new Pen(Color.Red, 0))
            {
                g.DrawRectangle(pen, rect);
            }
            g.DrawString("1\n2\n", this.Font, Brushes.Red, rect);
            g.Restore(state);
        }

        private void panelDraw_MouseClick(object sender, MouseEventArgs e)
        {
            using (Graphics g = this.CreateGraphics())
            {
                g.PageUnit = GraphicsUnit.Inch;
                g.PageScale = scale;
                PointF[] ptClick = new PointF[] {
                    new PointF(e.X, e.Y) };
                g.TransformPoints(CoordinateSpace.Page,
                    CoordinateSpace.Device,
                    ptClick);
                Point pt = Point.Truncate(ptClick[0]);
                if (rect.Contains(pt))
                {
                    toolStripStatusLabelMouseHit.Text = "Mouse Hit";
                } else
                {
                    toolStripStatusLabelMouseHit.Text = "Mouse Miss";
                }
            }

        }
    }
}
